
import Taro, { Component } from '@tarojs/taro'
import { View, Text, Button,Input } from '@tarojs/components'
import { AtInput, AtImagePicker, AtTextarea, Picker, AtModal, AtModalHeader, AtModalContent, AtModalAction } from 'taro-ui'

import InteractionComponent from '../../component/interactionComponent/interactionComponent'
import CopyrightComponent from '../../component/copyrightComponent/copyrightComponent'
import URL from '../../serviceAPI.config'
import './myNeedsEdit.scss'

class MyNeedsEdit extends Component {

  config = {
    navigationBarTitleText: '需求编辑'
  }
  constructor() {
    super(...arguments)
    this.state = {

      industryTypeSelected: '',
      needsType: [{ name: '业主需求', id: '4' }, { name: '效果图', id: '5' }],
      needsTypeSelected: { name: '业主需求', id: '4' },
      needsState: [
        { name: '作废', id: '0' },
        { name: '在用', id: '1' },
      ],
      needsStateSelected: { name: '全部', id: '' },
      title: '',
      sd_id: '', //需求id
      contactName: '',
      contactNumber: '',
      contactAddress: '',
      content: '',//描述
      pickerImageUrl: [],
      ImagesInfo: '',
      isDeleteModal: false,// 删除提示框
      isSave: false,//是否点击保存按钮
      isSaveAndNew: false,//是否点击保存新增按钮


    }
  }
  //获取需求信息api 
  getMyNeedEditInfo() {
    Taro.request({
      url: URL.EditMyNeeds,
      method: 'GET',
      dataType: 'json',
      data: {
        demandId: this.$router.params.id,
      },
      header: {
        'content-type': 'application/x-www-form-urlencoded',
        'Cookie': 'PFWSSS=' + Taro.getStorageSync('session_id'),
        'X-Requested-With': 'XMLHttpRequest'
      }
    })
      .then(res => {
        console.log('需求详情获取成功', res)
        // const selectedType = this.state.demandingSupplyCate.filter(item => item.id == res.data.sdInfo.sd_type)[0]
        // const selectedState = this.state.needsState.filter(item => item.id == res.data.sdInfo.state)[0]
        let industryType = {}
        const classId = res.data.sdInfo.class_id
        for (let outter of res.data.supplyTree) {
          if (outter.children) {
            for (let inner of outter.children) {
              if (inner.class_id === classId) {
                industryType.name = inner.class_name
                industryType.id = inner.class_id
                break
              }
            }
          }
          if (outter.class_id === classId) {
            industryType.name = outter.class_name
            industryType.id = outter.class_id
            break
          }
        }
        if (!Object.keys(industryType).length) {
          industryType.name = '全部'
          industryType.id = '-1'
        }



        const needsType = this.state.needsType.filter(item => {
          return item.id === res.data.sdInfo.sd_type
        })[0]
        const imageFile = res.data.sdInfo.file_path.map(item => { return { url: URL.Base + item.file_path } })
        const needsState = this.state.needsState.filter(item => {
          return item.id === res.data.sdInfo.state
        })[0]
        this.setState({
          sd_id: res.data.sdInfo.sd_id,
          industryTypeSelected: industryType,
          needsTypeSelected: needsType,
          title: res.data.sdInfo.sd_title,
          contactName: res.data.sdInfo.user_name,
          contactNumber: res.data.sdInfo.user_phone,
          contactAddress: res.data.sdInfo.user_address,
          content: res.data.sdInfo.sd_desc,
          needsStateSelected: needsState,
          pickerImageUrl: imageFile,
          ImagesInfo: res.data.sdInfo.file_path,
        })
        Taro.hideLoading()
      }

      )
      .catch(error => {
        console.log('供求详情获取失败', error)
      })
  }



  // uploadMyNeedsApi 上传需求 的api
  uploadMyNeedsApi() {

    const file_path = [];
    this.state.ImagesInfo.forEach((item) => {
      file_path.push({
        file_name: item.file_name,
        file_size: item.file_size,
        file_path: item.file_path,
        thumb_path: item.thumb_path
      })
    })
    Taro.request({
      url: URL.PublishMyNeed,
      method: 'POST',
      dataType: 'json',
      data: {
        action: 2,
        sdInfo: JSON.stringify({
          class_id: this.state.industryTypeSelected.id,
          sd_id: this.state.sd_id,
          sd_type: this.state.needsTypeSelected.id,
          sd_title: this.state.title,
          user_name: this.state.contactName,
          user_phone: this.state.contactNumber,
          user_address: this.state.contactAddress,
          sd_desc: this.state.content,
          state: this.state.needsStateSelected.id,
          file_path: file_path,

        })
      },
      header: {
        'content-type': 'application/x-www-form-urlencoded',
        'Cookie': 'PFWSSS=' + Taro.getStorageSync('session_id'),
        'X-Requested-With': 'XMLHttpRequest'
      }
    })
      .then(res => {
        console.log('上传需求', res)
        Taro.hideLoading()
        if (res.data.err_msg === 'success') {
          Taro.showToast({
            title: '保存成功',
            icon: 'success',
            duration: 1500
          }).then(() => {
            setTimeout(() => {
              if (this.state.isSave) {
                Taro.navigateTo({
                  url: '/pages/myNeedsEdit/myNeedsEdit?id=' + this.state.sd_id
                })
              } else if (this.state.isSaveAndNew) {
                Taro.navigateTo({
                  url: '/pages/myNeedsPublish/myNeedsPublish'
                })
              }

            }, 1500);
          })

        } else {
          Taro.showToast({
            title: res.data.err_msg,
            icon: 'none',
            duration: 1500
          })
        }

      }
      )

  }

  // 上传图片
  onChangeImg(files, operationType, index) {
    const that = this
    if (operationType === 'add') {
      Taro.uploadFile({
        url: URL.UploadDSPorductImage,
        filePath: files[files.length - 1].url,
        name: 'file',
        header: {
          'content-type': 'multipart/form-data',
          'Cookie': 'PFWSSS=' + Taro.getStorageSync('session_id'),
          'X-Requested-With': 'XMLHttpRequest'
        },
        success(response) {
          const data = JSON.parse(response.data)
          const imagePath = URL.Base + data.file_path
          const newPickerImageUrl = that.state.pickerImageUrl.concat({ url: imagePath })
          const newImageInfo = that.state.ImagesInfo.concat(data)
          that.setState({
            pickerImageUrl: newPickerImageUrl,
            ImagesInfo: newImageInfo
          })
          Taro.showToast({
            title: '上传成功',
            icon: 'success',
            duration: 1500
          })
        }
      })
    }
    if (operationType === 'remove') {
      this.state.ImagesInfo.splice(index, 1) // 删除显示的图片
      this.state.pickerImageUrl.splice(index, 1)// 删除图片param
      that.setState({
        pockerImageUrl: this.state.pickerImageUrl,
        ImagesInfo: this.state.ImagesInfo,
      })
      Taro.showToast({
        title: '删除成功',
        icon: 'success',
        duration: 1500
      })
    }
  }

  //删除我的需求 api DeleteMyNeeds
  deleteMyNeeds({ demandId = 10 }) {
    Taro.request({
      url: URL.DeleteMyNeeds,
      method: 'POST',
      dataType: 'json',
      data: {

        demandId: demandId

      },
      header: {
        'Cookie': 'PFWSSS=' + Taro.getStorageSync('session_id'),
        'content-type': 'application/x-www-form-urlencoded',
        'X-Requested-With': 'XMLHttpRequest'
      }
    }).then(res => {
      console.log('删除我的列表', res)
      if (res.data.err_msg === "success") {
        Taro.showToast({
          title: '删除成功',
          icon: 'success',
          duration: 1000
        })
        setTimeout(() => {
          Taro.navigateTo({
            url: '/pages/myNeedsPublish/myNeedsPublish'
          })
        }, 1000);
      } else {
        Taro.showToast({
          title: res.data.err_msg,
          icon: 'none',
          duration: 1500
        })
      }
    })

  }
  // 修改需求类型
  needsTypeChange = e => {
    this.setState({
      needsTypeSelected: this.state.needsType[e.detail.value]
    })
  }
  // 修改供求状态
  needsStateChange = e => {
    this.setState({
      needsStateSelected: this.state.needsState[e.detail.value]
    })
  }
  //改标题
  titleChange(event) {
    this.setState({ title: event })
  }
  contactNameChange(event) {
    this.setState({ contactName: event })
  }
  contactNumberChange(event) {
    this.setState({ contactNumber: event })
  }
  contactAddressChange(event) {
    this.setState({ contactAddress: event.target.value })
  }
  contentChange(event) {
    this.setState({ content: event.target.value })
  }
  goToMyNeedsPage() {
    Taro.navigateTo({
      url: '/pages/myNeeds/myNeeds'
    })
  }
  // 保存需求按钮
  saveButtonHandler() {
    if (this.state.title &&
      this.state.contactName
      && this.state.contactNumber
      && this.state.content && this.state.needsStateSelected) {
      Taro.showLoading({
        title: '保存中'
      })
      this.setState({ isSave: true }, () => {
        this.uploadMyNeedsApi({})
      })

    } else {
      Taro.showToast({
        title: '请填写完表格',
        icon: 'none',
        duration: 1500
      })
    }

  }
  // 保存新增按钮
  saveAndNewButton() {
    if (this.state.title &&
      this.state.contactName
      && this.state.contactNumber
      && this.state.content && this.state.needsStateSelected) {
      Taro.showLoading({
        title: '保存中'
      })
      this.setState({ isSaveAndNew: true }, () => {
        this.uploadMyNeedsApi({})
      })
    } else {
      Taro.showToast({
        title: '请填写完表格',
        icon: 'none',
        duration: 1500
      })
    }

  }

  deleteButtonHandler() {
    this.setState({ isDeleteModal: true })
  }

  handleWindowModCancel() {
    this.setState({ isDeleteModal: false })
  }
  handleWindowConfirm() {
    this.setState({ isDeleteModal: false })
    this.deleteMyNeeds({ demandId: this.state.sd_id })
  }

  getDataFromChild(value) {
    console.log('从子组件传回来的值', value)
    this.setState({ industryTypeSelected: value })
  }


  componentDidMount() {

    Taro.showLoading({ title: '加载中' })
    this.getMyNeedEditInfo()
  }
  componentWillReceiveProps(nextProps) {
    console.log(this.props, nextProps)
  }

  componentWillUnmount() { }

  componentDidShow() { }

  componentDidHide() { }

  render() {
    const deleteModalWindowElement = <AtModal isOpened={this.state.isDeleteModal}>
      <AtModalHeader>提示</AtModalHeader>
      <AtModalContent>
        确认删除{this.state.needsItem.sd_title}？
    </AtModalContent>
      <AtModalAction>  <Button onClick={this.handleWindowModCancel.bind(this)}>取消</Button> <Button className='orange' onClick={this.handleWindowConfirm.bind(this)}>确定</Button>  </AtModalAction>
    </AtModal>

    return (
      <View className='supply-demand'>
        {deleteModalWindowElement}
        {/* 行业分类 */}
        <InteractionComponent url={URL.GetIndustryTypeList} onPassDataToChild={this.getDataFromChild.bind(this)} selectedValue={this.state.industryTypeSelected} ></InteractionComponent>

        {/* 需求类型 */}
        <View className='page-section'>
          <View>
            <Picker mode='selector' rangeKey='name' range={this.state.needsType} onChange={this.needsTypeChange.bind(this)}>
              <View className='picker'>
                <View className='title-box'>
                  <Text className='title'><Text className='require'>*</Text>需求类型:</Text> <Text className='selected'>{this.state.needsTypeSelected.name}</Text>
                </View>

              </View>
            </Picker>
          </View>
        </View>
        <View className='border-box'>
          <Text className='require'>*</Text><AtInput
            name='value'
            title='需求标题：'
            type='text'
            value={this.state.title}
            border={false}
            onChange={this.titleChange.bind(this)}

          />

        </View>
        <View className='input-box'>
          <Text className='require'>*</Text>
          <AtInput
            name='value'
            title='联系人：'
            type='text'
            value={this.state.contactName}
            border={false}
            onChange={this.contactNameChange.bind(this)}
          />
        </View>
        <View className='input-box' style='padding:24rpx 0;font-size:32rpx'>
          <View className='title' style='font-weight:bold;'>
            <Text style='color:red'>*</Text>
            <Text>联系电话：</Text>
          </View>
          <View style='margin-left:5%;'>
            <Input name='value'
              maxLength='11'
              type='number'
              value={this.state.contactNumber}
              onInput={this.contactNumberChange.bind(this)}
            /></View>
        </View>
       
        <View className='demanding-box'>
          <View className='title-box'>
            <Text className='title'>联系地址:</Text>
          </View>

          <AtTextarea
            value={this.state.contactAddress}
            onChange={this.contactAddressChange.bind(this)}
            maxlength='200'
            placeholder='联系地址'
          />
        </View>
        <View className='demanding-box'>
          <View className='title-box'>
            <Text className='title'><Text className='require'>*</Text>需求内容:</Text>
          </View>
          <AtTextarea
            value={this.state.content}
            onChange={this.contentChange.bind(this)}
            maxlength='200'
            placeholder=''
          />
        </View>
        <View className='img-box'>
          <View className='title-box'>
            <Text className='title'>需求图片:</Text>
            <View className='warn'>(最多4张)</View>
          </View>

          <View className='img-container'>
            <AtImagePicker
              multiple
              showAddBtn={this.state.pickerImageUrl.length < 4}
              files={this.state.pickerImageUrl}
              onChange={this.onChangeImg.bind(this)}
              onFail={this.onFail.bind(this)}
              onImageClick={this.onImageClick.bind(this)}
            />
          </View>

        </View>
        <View className='page-section'>

          <View>
            <Picker mode='selector' rangeKey='name' range={this.state.needsState} onChange={this.needsStateChange.bind(this)}>
              <View className='picker'>
                <View className='title-box'>
                  <Text className='title'> <Text className='require'>*</Text>状态:</Text> <Text className='selected'>{this.state.needsStateSelected.name}</Text>
                </View>

              </View>
            </Picker>
          </View>
        </View>

        <View className='button-box'>
          <View className='button' onClick={this.saveButtonHandler.bind(this)}>
            <Button size='mini' className='button-orange'>保存</Button>
          </View>
          <View className='button' onClick={this.saveAndNewButton.bind(this)}>
            <Button size='mini' className='button-green'>保存并新增</Button>
          </View>
          <View className='button' onClick={this.goToMyNeedsPage.bind(this)}>
            <Button className='button-green' size='mini'>我的需求</Button>
          </View>
          <View className='button' onClick={this.deleteButtonHandler.bind(this)}>
            <Button className='button-dark-red' size='mini'>删除</Button>
          </View>
        </View>
        <CopyrightComponent></CopyrightComponent>


      </View>
    )
  }
}

export default MyNeedsEdit
